#include "mv.hh"
#include <stdlib.h> // for rand() function

// initialize structure to a vector of size 0
Vec::Vec() {
  cout << "Call constructor for Vec\n" ;
  _size  = 0 ;
  values = nullptr ;
}

Vec::Vec( int _sz ) : _size(_sz) {
  cout << "Call constructor for Vec with size = " << _size << "\n" ;
  values = new double[_size] ; // allocate memory for the vector
}

Vec::~Vec( ) {
  cout << "Call detructor for Vec\n" ;
  // check if alreay de-allocated
  if ( values != nullptr ) delete [] values ;
  _size = 0 ;
}

// alocate a vector to teh size: size
void
Vec::allocate( int size ) {
  _size = size ;
  // check if alreay allocated
  if ( values != nullptr ) delete [] values ;
  values = new double[_size] ;
}

void
Vec::fill( double val ) {
  for ( int i = 0 ; i < _size ; ++i )
    values[i] = val ;
}

void
Vec::fill_random() {
  for ( int i = 0 ; i < _size ; ++i )
    values[i] = (rand() - rand())/double(RAND_MAX) ;
}

/*
 ___    _____  
|_ _|  / / _ \ 
 | |  / / | | |
 | | / /| |_| |
|___/_/  \___/ 

*/

ostream &
operator << ( ostream & stream, Vec const & vec ) {
  stream << vec(0) ;
  for ( int i = 1 ; i < vec.size() ; ++i )
    stream << " " << vec(i) ;
  stream << '\n' ;
  return stream ;
}
